﻿---------------------------------
-- Addon:   MatheQuiz!
-- Author:  Neoxx, Nera'thor - EU
-- Version: Beta
---------------------------------

--[[
- Funktionen fangen mit einem großen Buchstaben an.
- Variablen fangen mit einem kleinen Buchstaben an.
- Präfixe fangen mit einem '_' an.
- '' wird verwendet und '""'
]]

local L = LibStub('AceLocale-3.0'):GetLocale('MatheQuiz', true);

local autorAddon = L['AUTOR_ADDON'];
local versionAddon = L['VERSION_ADDON'];

local fragenAuswahl = 5;
local autoAntwortBoolean = false;
local antwortBoolean = false;

local message;
local author;
local a;
local b;
local c;
local d;
-- Quizstatus 0 = no quiz, 1 = started, 2 = awaiting answer, 3 = correct answer received
local quizStatus = 0;

function MQ_OnLoad()
	--Register slash commands
	SLASH_MATHEQUIZ1 = L['BEFEHL_MQ'], L['BEFEHL_MATHEQUIZ'];
	local function handler(msg)
		local command, rest = msg:match('^(%S*)%s*(.-)$');
			if (command == L['BEFEHL_START']) then
				MQ_Start();
			elseif (command == L['BEFEHL_STOPP']) then
				MQ_Stop();		
			elseif (command == L['BEFEHL_VERSION']) then
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_VERSION_VAR_X'](versionAddon));	
			elseif (command == L['BEFEHL_AUTOR']) then
				DEFAULT_CHAT_FRAME:AddMessage(autorAddon);
			elseif (command == L['BEFEHL_EXPERIMENT']) then
				experiment = string.upper(rest);
				Experiment_Funktion();
			elseif (command == L['BEFEHL_AUTOANTWORT']) then
				autoAntwortString = string.upper(rest);
				AutoAntwort_Funktion();
			elseif (command == L['BEFEHL_ANTWORT']) then
				antwortString = string.upper(rest);
				Antwort_Funktion();
			elseif (command == L['BEFEHL_BESTENLISTE']) then
				MQ_TopScores();
			elseif (command == L['BEFEHL_BESTENLISTE_BEREICH']) then
				settings.topScoreListNr = tonumber(rest);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_BESTENLISTE_BEREICH_VAR_X'](settings.topScoreListNr));
			elseif (command == L['BEFEHL_BESTENLISTE_RESET']) then
				MQ_ResetScore();			
			elseif (command == L['BEFEHL_ANTWORTZEIT']) then
				settings.timeToAnswer = tonumber(rest);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_ANTWORTZEIT_VAR_X'](settings.timeToAnswer));
			elseif (command == L['BEFEHL_WARTEZEIT']) then
				settings.timeBetweenQuestions = tonumber(rest);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_WARTEZEIT_VAR_X'](settings.timeBetweenQuestions));
			elseif (command == L['BEFEHL_AUSGABE']) then
				settings.outputChannel = string.upper(rest);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABE_VAR_X'](settings.outputChannel));
			elseif (command == L['BEFEHL_AUSGABE_KANALNUMMER']) then
				settings.outputChannelId = tonumber(rest);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABE_KANALNUMMER_VAR_X'](settings.outputChannelId));
			elseif (command == L['BEFEHL_AUSGABE_INFO']) then
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_SAY']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_YELL']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_GUILD']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_OFFICER']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_PARTY']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_RAID']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_RAID_WARNING']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_BATTLEGROUND']);
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_AUSGABEINFO_CHANNEL']);
			elseif (command == L['BEFEHL_EINSTELLUNGEN']) then
				DEFAULT_CHAT_FRAME:AddMessage(L['BEFEHL_EINSTELLUNGEN_VAR_X_Y_Z_X1'](settings.outputChannel, settings.timeToAnswer, settings.timeBetweenQuestions, settings.topScoreListNr));
			elseif (command == L['BEFEHL_EINSTELLUNGEN_RESET']) then
				MQ_ResetSettings();	
			else
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_CHATBEFEHLE']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_START_STOPP_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_START_STOPP_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_VERSION_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_VERSION_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUTOR_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUTOR_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_EXPERIMENT_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_EXPERIMENT_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUTOANTWORT_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUTOANTWORT_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_ANTWORT_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_ANTWORT_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_BESTENLISTE_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_BESTENLISTE_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_BESTENLISTE_BEREICH_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_BESTENLISTE_BEREICH_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_BESTENLISTE_RESET_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_BESTENLISTE_RESET_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_ANTWORTZEIT_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_ANTWORTZEIT_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_WARTEZEIT_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_WARTEZEIT_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUSGABE_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUSGABE_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUSGABE_2']);		
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUSGABE_KANALNUMMER_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUSGABE_KANALNUMMER_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUSGABE_INFO_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_AUSGABE_INFO_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_EINSTELLUNGEN_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_EINSTELLUNGEN_2']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_EINSTELLUNGEN_RESET_1']);
				DEFAULT_CHAT_FRAME:AddMessage(L['INFO_EINSTELLUNGEN_RESET_2']);
			end
	end	
	
	SlashCmdList['MATHEQUIZ'] = handler;
	if (settings ~= nil) then
		settings = settings;
	else
		settings = { outputChannel = 'GUILD', topScoreListNr = 3, timeToAnswer = 15, timeBetweenQuestions = 5, outputChannelId = nil};
	end	
	
	if (scores ~= nil) then
		scores = scores;
	else
		scores = { };
	end

end

function MQ_Stop()
	if (quizStatus > 0) then
		quizStatus = 0;
		local arg8 = settings.outputChannelId;
		MatheQuizFrame:UnregisterEvent('CHAT_MSG_'..settings.outputChannel);
		SendChatMessage(L['MQ_STOP'], settings.outputChannel, nil, settings.outputChannelId);
		MatheQuizFrame:SetScript('OnUpdate', nil);
		MQ_TopScores();
	else
		DEFAULT_CHAT_FRAME:AddMessage(L['FEHLER_QUIZ_AUS'], 1.0, 0.0, 0.0);
	end
end

function MQ_Start()
	if (quizStatus == 0) then
		SendChatMessage(L['MQ_START_VAR_X'](settings.timeBetweenQuestions), settings.outputChannel, nil, settings.outputChannelId);
		quizStatus = 1;
		MatheQuizFrame:SetScript('OnUpdate', MQ_OnUpdate); 
		MatheQuizFrame.TimeSinceLastUpdate = 0;
	else
		DEFAULT_CHAT_FRAME:AddMessage(L['FEHLER_QUIZ_AN'], 1.0, 0.0, 0.0);
	end
end

function MQ_CreateQuestion()
	local z = math.random(0, fragenAuswahl);
	if (z == 0) then
		-- + 
		a = math.random(0, 200);
		b = math.random(0, 200);
		c = a + b;
		d = '+';
	elseif (z == 1) then
		-- -
		a = math.random(0, 200);
		b = math.random(0, 200);
		c = a - b;
		d = '-';
	elseif (z == 2) then
		-- *
		a = math.random(0, 20);
		b = math.random(0, 20);
		c = a * b;
		d = '*';
	elseif (z == 3) then
		-- /
		a = math.random(0, 1000);
		b = 2;
		c = a / b;
		d = '/';
	elseif (z == 4) then
		-- ^1/2
		a = Mathe_Wurzel();
		b = '(1/2) '..L['QUADRATWURZEL'];
		c = math.sqrt (a);
		d = '^';		
	elseif (z == 5) then
		--^
		a = math.random(0, 20);
		b = math.random(0, 2);
		c = a^b;
		d = '^';	
	elseif (z == 6) then
		-- /
		a = math.random(0, 100);
		b = math.random(1, 5);
		c = a / b;
		d = '/';
	end
	local arg8 = settings.outputChannelId;
	MatheQuizFrame:RegisterEvent('CHAT_MSG_'..settings.outputChannel);
	SendChatMessage(L['MQ_FRAGE_VAR_X_Y_Z'](a, d, b), settings.outputChannel, nil, settings.outputChannelId);
	quizStatus = 2;
	if (antwortBoolean == true) then
		DEFAULT_CHAT_FRAME:AddMessage(L['MQ_ANTWORT_VAR_X'](c), 1.0, 0.5, 0.0);
	end
end

function MQ_OnUpdate(self, elapsed)
	if (quizStatus == 0) then
		return;
	elseif (quizStatus == 1) then
		MatheQuizFrame.TimeSinceLastUpdate = MatheQuizFrame.TimeSinceLastUpdate + elapsed;
		if (MatheQuizFrame.TimeSinceLastUpdate > settings.timeBetweenQuestions) then
			MQ_CreateQuestion();
			timeWarning = 0;
			MatheQuizFrame.TimeSinceLastUpdate = 0;
			if (autoAntwortBoolean == true) then
				SendChatMessage(c, settings.outputChannel, nil, settings.outputChannelId);
			end	
		else
			return;
		end
	elseif (quizStatus == 2) then
		MatheQuizFrame.TimeSinceLastUpdate = MatheQuizFrame.TimeSinceLastUpdate + elapsed;
		if ((MatheQuizFrame.TimeSinceLastUpdate > (settings.timeToAnswer / 2)) and (timeWarning == 0)) then
			SendChatMessage((settings.timeToAnswer / 2)..L['MQ_RESTZEIT'], settings.outputChannel, nil, settings.outputChannelId);
			timeWarning = 1;
		elseif (MatheQuizFrame.TimeSinceLastUpdate > settings.timeToAnswer) then
			SendChatMessage(L['MQ_ZEIT_UM_VAR_X'](c), settings.outputChannel, nil, settings.outputChannelId);
			quizStatus = 3;
		end
	elseif (quizStatus == 3) then
		quizStatus = 1;
		MatheQuizFrame.TimeSinceLastUpdate = 0;
	end
end

function MQ_TopScores()
	MQ_SortTopScore();
	local x = 1;
	SendChatMessage(L['MQ_BESTENLISTE'], settings.outputChannel, nil, settings.outputChannelId);
	while x <= settings.topScoreListNr do
		if (scores[x] ~= nil) then
			SendChatMessage(scores[x].name..': '..scores[x].points, settings.outputChannel, nil, settings.outputChannelId);
			x = x + 1;
		else
			return;
		end
	end
end

function MQ_SortTopScore()
	table.sort(scores, function(a1,a2) return a1.points > a2.points end)
end
	
function MQ_EventHandler(event, ...)
	local arg8 = settings.outputChannelId;
	if (event == 'CHAT_MSG_'..settings.outputChannel and quizStatus == 2) then
		message = arg1;
		author = arg2;
		if (message == tostring(c)) then
			playerData = MQ_GetPlayerData(author)		
			playerData.points = playerData.points + 1;
			SendChatMessage(L['MQ_ANTWORT_RICHTIG'](playerData.name, c, playerData.points), settings.outputChannel, nil, settings.outputChannelId);			
			MatheQuizFrame:UnregisterEvent('CHAT_MSG_'..settings.outputChannel);
			quizStatus = 3;
		end
	end
end

function MQ_ResetScore()
	scores = {};
	DEFAULT_CHAT_FRAME:AddMessage(L['MQ_SCORE_RESET'], 1.0, 0.5, 0.0);
end

function MQ_ResetSettings()
	settings = { outputChannel = 'GUILD', topScoreListNr = 3, timeToAnswer = 15, timeBetweenQuestions = 5, outputChannelId = nil};
	DEFAULT_CHAT_FRAME:AddMessage(L['MQ_SETTINGS_RESET'], 1.0, 0.5, 0.0);
end
	
function MQ_GetPlayerData(playername)
	if (scores[1] ~= nil) then
		for i,v in ipairs(scores) do
			if (v.name == playername) then
				return v;
			end
		end		
		playerData = {name = playername, points = 0};
		table.insert(scores, playerData);
		return playerData;
	else 
		playerData = {name = playername, points = 0};
		table.insert(scores, playerData);
		return playerData;	
	end
end

-- weitere Funktionen
function Mathe_Wurzel()
	local w = math.random(0, 20);
	return math.pow (w, 2);		
end

function Experiment_Funktion()
	if (experiment == L['AN']) then
		fragenAuswahl = 6;
		DEFAULT_CHAT_FRAME:AddMessage(L['EXPERIMENT_MODUS_STATUS'](experiment), 0.0, 1.0, 0.0);
	elseif (experiment == L['AUS']) then
		fragenAuswahl = 5;
		DEFAULT_CHAT_FRAME:AddMessage(L['EXPERIMENT_MODUS_STATUS'](experiment), 1.0, 0.5, 0.0);
	else
		DEFAULT_CHAT_FRAME:AddMessage(L['EINGABE_INKORREKT'], 1.0, 0.0, 0.0);		
	end	
end

function AutoAntwort_Funktion()
	if (autoAntwortString == L['AN']) then
		autoAntwortBoolean = true;
		DEFAULT_CHAT_FRAME:AddMessage(L['AUTOANTWORT_MODUS_STATUS'](autoAntwortString), 0.0, 1.0, 0.0);
	elseif (autoAntwortString == L['AUS']) then
		autoAntwortBoolean = false;
		DEFAULT_CHAT_FRAME:AddMessage(L['AUTOANTWORT_MODUS_STATUS'](autoAntwortString), 1.0, 0.5, 0.0);
	else
		DEFAULT_CHAT_FRAME:AddMessage(L['EINGABE_INKORREKT'], 1.0, 0.0, 0.0);	
	end
end	

function Antwort_Funktion()
	if (antwortString == L['AN']) then
		antwortBoolean = true;
		DEFAULT_CHAT_FRAME:AddMessage(L['ANTWORT_MODUS_STATUS'](antwortString), 0.0, 1.0, 0.0);
	elseif (antwortString == L['AUS']) then
		antwortBoolean = false;
		DEFAULT_CHAT_FRAME:AddMessage(L['ANTWORT_MODUS_STATUS'](antwortString), 1.0, 0.5, 0.0);
	else
		DEFAULT_CHAT_FRAME:AddMessage(L['EINGABE_INKORREKT'], 1.0, 0.0, 0.0);	
	end
end

-- /script SendChatMessage("TEST" ,"CHANNEL" ,GetDefaultLanguage("player") ,"6");